package syscon.arbutus.product.services.legal.contract.dto.caseactivity;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import syscon.arbutus.product.services.core.contract.dto.CommentType;
import syscon.arbutus.product.services.core.contract.dto.StampType;

/**
 * Case Activity Type.
 *
 * @author lhan
 */
public class CaseActivityType implements Serializable {

    private static final long serialVersionUID = -5493213689773199362L;

    /**
     * The unique ID for each case related event/activity created in the system. This is a system generated ID.
     */
    private Long caseActivityIdentification;

    /**
     * The date the case activity occurred. This is NOT the same as a “created date”. - Required
     */
    @NotNull
    private Date activityOccurredDate;

    /**
     * The broad category under which the event is classified.
     * Note that this determines which specific type of activity is created.
     * E.g Court, Probation, Police. - Required
     */
    @NotNull
    private String activityCategory;

    /**
     * The specific event type that falls under the activity category. E.g. Arraignment, Trial, Sentencing - Required
     */
    @NotNull
    private String activityType;

    /**
     * Any comments associated with the event or activity - Optional
     */
    private CommentType activityComment;

    /**
     * An outcome that may be recorded as a result of the activity - Optional
     */
    private String activityOutcome;

    /**
     * System auto-generated outcome date indicates when the activity outcome is recorded or updated. - ignored
     */
    private Date outcomeDate;

    /**
     * The status of the case activity.
     * If the status is active, the activity is considered to be relevant ie. Scheduled to occur or is completed.
     * If the status is inactive, the activity is no longer relevant ie. cancelled or no longer required. - Required
     */
    @NotNull
    private String activityStatus;

    /**
     * Indicates the list of charges that are part of the case event. This is a static reference to the Charge service. - Optional
     */
    private Set<Long> chargeIds;

    /**
     * Associations to CaseInfoType objects, at least one. Required
     */
    @NotNull
    @Size(min = 1, message = "Must have at least refer to one CaseInfoType object")
    private Set<Long> caseIds;

    /**
     * Associations to ActivityType objects, 0 or 2. Optional
     */
    @Size(min = 2, max = 2, message = "Have to refer to two ActivityType objects")
    private Set<Long> activityIds;

    /**
     * Associations to CaseAffiliationType objects. Optional
     */
    private Set<Long> caseAffiliationIds;

    /**
     * Stamp information is generated by system.
     */
    private StampType stamp;

    /**
     * Constructor
     */
    public CaseActivityType() {
        super();
    }

    /**
     * Constructor
     *
     * @param caseActivityIdentification Long - Optional when creating. The unique ID for each case related event/activity created in the system. This is a system generated ID.
     * @param activityOccurredDate       Date - The date the case activity occurred. This is NOT the same as a “created date”. - Required
     * @param activityCategory           String - The broad category under which the event is classified. - Required
     * @param activityType               String - The specific event type that falls under the activity category. E.g. Arraignment, Trial, Sentencing - Required
     * @param activityComment            CommentType - Any comments associated with the case event or activity - Optional
     * @param activityOutcome            String - An outcome that may be recorded as a result of the activity - Optional
     * @param outcomeDate                Date - System auto-generated outcome date indicates when the activity outcome is recorded. - ignored
     * @param activityStatus             String - The status of the case activity. Required
     * @param chargeIds                  Set<Long> - Indicates the list of charges that are part of the case event. This is a static reference to the Charge service. - Optional
     * @param caseIds                    Set<Long> -  Associations to CaseInfoType objects, at least one. Required
     * @param activityIds                Set<Long> - Associations to either 0 or 2 ActivityType objects. Optional
     * @param caseAffiliationIds         Set<Long> - Associations to CaseAffiliationType objects. Optional
     * @param stamp                      StampType - Ignored - Stamp information is generated by system.
     */
    public CaseActivityType(Long caseActivityIdentification, Date activityOccurredDate, String activityCategory, String activityType, CommentType activityComment,
            String activityOutcome, Date outcomeDate, String activityStatus, Set<Long> chargeIds, Set<Long> caseIds, Set<Long> activityIds, Set<Long> caseAffiliationIds,
            StampType stamp) {
        super();
        this.caseActivityIdentification = caseActivityIdentification;
        this.activityOccurredDate = activityOccurredDate;
        this.activityCategory = activityCategory;
        this.activityType = activityType;
        this.activityComment = activityComment;
        this.activityOutcome = activityOutcome;
        this.outcomeDate = outcomeDate;
        this.activityStatus = activityStatus;
        this.chargeIds = chargeIds;
        this.caseIds = caseIds;
        this.activityIds = activityIds;
        this.caseAffiliationIds = caseAffiliationIds;
        this.stamp = stamp;
    }

    /**
     * Constructor
     *
     * @param caseActivity
     */
    public CaseActivityType(CaseActivityType caseActivity) {
        super();
        this.caseActivityIdentification = caseActivity.getCaseActivityIdentification();
        this.activityOccurredDate = caseActivity.getActivityOccurredDate();
        this.activityCategory = caseActivity.getActivityCategory();
        this.activityType = caseActivity.getActivityType();
        this.activityComment = caseActivity.getActivityComment();
        this.activityOutcome = caseActivity.getActivityOutcome();
        this.outcomeDate = caseActivity.getOutcomeDate();
        this.activityStatus = caseActivity.getActivityStatus();
        this.chargeIds = caseActivity.getChargeIds();
        this.caseIds = caseActivity.getCaseIds();
        this.activityIds = caseActivity.getActivityIds();
        this.caseAffiliationIds = caseActivity.getCaseAffiliationIds();
        this.stamp = caseActivity.getStamp();
    }

    /**
     * The unique ID for each case related event/activity created in the system. This is a system generated ID.
     *
     * @return the caseActivityIdentification
     */
    public Long getCaseActivityIdentification() {
        return caseActivityIdentification;
    }

    /**
     * The unique ID for each case related event/activity created in the system. This is a system generated ID.
     *
     * @param caseActivityIdentification the caseActivityIdentification to set
     */
    public void setCaseActivityIdentification(Long caseActivityIdentification) {
        this.caseActivityIdentification = caseActivityIdentification;
    }

    /**
     * The date the event or activity occurred. This is NOT the same as a “created date”.
     *
     * @return the activityOccurredDate
     */
    public Date getActivityOccurredDate() {
        return activityOccurredDate;
    }

    /**
     * The date the event or activity occurred. This is NOT the same as a “created date”.
     *
     * @param activityOccurredDate the activityOccurredDate to set
     */
    public void setActivityOccurredDate(Date activityOccurredDate) {
        this.activityOccurredDate = activityOccurredDate;
    }

    /**
     * The broad category under which the event is classified.
     * Note that this determines which specific type of activity is created.
     * It is a reference code of case activity category set
     *
     * @return the activityCategory
     */
    public String getActivityCategory() {
        return activityCategory;
    }

    /**
     * The broad category under which the event is classified.
     * Note that this determines which specific type of activity is created.
     * It is a reference code of case activity category set
     *
     * @param activityCategory the activityCategory to set
     */
    public void setActivityCategory(String activityCategory) {
        this.activityCategory = activityCategory;
    }

    /**
     * The specific event type that falls under the activity category
     * It is a reference code of case activity type set
     *
     * @return the activityType
     */
    public String getActivityType() {
        return activityType;
    }

    /**
     * The specific event type that falls under the activity category
     * It is a reference code of case activity type set
     *
     * @param activityType the activityType to set
     */
    public void setActivityType(String activityType) {
        this.activityType = activityType;
    }

    /**
     * Any comments associated with the event or activity
     *
     * @return the activityComment
     */
    public CommentType getActivityComment() {
        return activityComment;
    }

    /**
     * Any comments associated with the event or activity
     *
     * @param activityComment the activityComment to set
     */
    public void setActivityComment(CommentType activityComment) {
        this.activityComment = activityComment;
    }

    /**
     * An outcome that may be recorded as a result of the activity
     * It is a reference code of case activity outcome set
     *
     * @return the activityOutcome
     */
    public String getActivityOutcome() {
        return activityOutcome;
    }

    /**
     * An outcome that may be recorded as a result of the activity
     * It is a reference code of case activity outcome set
     *
     * @param activityOutcome the activityOutcome to set
     */
    public void setActivityOutcome(String activityOutcome) {
        this.activityOutcome = activityOutcome;
    }

    /**
     * System auto-generated outcome date indicates when the activity outcome is recorded or updated. - ignored
     *
     * @return the outcomeDate
     */
    public Date getOutcomeDate() {
        return outcomeDate;
    }

    /**
     * System auto-generated outcome date indicates when the activity outcome is recorded or updated. - ignored
     *
     * @param outcomeDate the outcomeDate to set
     */
    public void setOutcomeDate(Date outcomeDate) {
        this.outcomeDate = outcomeDate;
    }

    /**
     * The status of the activity which indicates whether it has occurred/completed,
     * is planned for some time in the future or was supposed to occur but was not completed for some reason
     * It is a reference code of case activity status set
     *
     * @return the activityStatus
     */
    public String getActivityStatus() {
        return activityStatus;
    }

    /**
     * The status of the activity which indicates whether it has occurred/completed,
     * is planned for some time in the future or was supposed to occur but was not completed for some reason
     * It is a reference code of case activity status set
     *
     * @param activityStatus the activityStatus to set
     */
    public void setActivityStatus(String activityStatus) {
        this.activityStatus = activityStatus;
    }

    /**
     * Indicates the list of charges that are part of the case event.
     * This is a static reference to the Charge service.
     *
     * @return the chargeAssociations
     */
    public Set<Long> getChargeIds() {
        return chargeIds;
    }

    /**
     * Indicates the list of charges that are part of the case event.
     * This is a static reference to the Charge service.
     *
     * @param chargeIds the chargeIds to set
     */
    public void setChargeIds(Set<Long> chargeIds) {
        this.chargeIds = chargeIds;
    }

    /**
     * Associations to CaseInfoType objects, at least one. Required
     *
     * @return the caseIds
     */
    public Set<Long> getCaseIds() {
        if (caseIds == null) {
			caseIds = new HashSet<Long>();
		}
        return caseIds;
    }

    /**
     * Associations to CaseInfoType objects, at least one. Required
     *
     * @param caseIds the caseIds to set
     */
    public void setCaseIds(Set<Long> caseIds) {
        this.caseIds = caseIds;
    }

    /**
     * Associations to ActivityType objects, 0 or 2. Optional
     *
     * @return the activityIds
     */
    public Set<Long> getActivityIds() {
        if (activityIds == null) {
			activityIds = new HashSet<Long>();
		}
        return activityIds;
    }

    /**
     * Associations to ActivityType objects, 0 or 2. Optional
     *
     * @param activityIds the activityIds to set
     */
    public void setActivityIds(Set<Long> activityIds) {
        this.activityIds = activityIds;
    }

    /**
     * Associations to CaseAffiliationType objects. Optional
     *
     * @return the caseAffiliationIds
     */
    public Set<Long> getCaseAffiliationIds() {
        if (caseAffiliationIds == null) {
			caseAffiliationIds = new HashSet<Long>();
		}
        return caseAffiliationIds;
    }

    /**
     * Associations to CaseAffiliationType objects. Optional
     *
     * @param caseAffiliationIds the caseAffiliationIds to set
     */
    public void setCaseAffiliationIds(Set<Long> caseAffiliationIds) {
        this.caseAffiliationIds = caseAffiliationIds;
    }

    /**
     * @return the stamp
     */
    public StampType getStamp() {
        return stamp;
    }

    /**
     * @param stamp the stamp to set
     */
    public void setStamp(StampType stamp) {
        this.stamp = stamp;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((activityCategory == null) ? 0 : activityCategory.hashCode());
        result = prime * result + ((activityComment == null) ? 0 : activityComment.hashCode());
        result = prime * result + ((activityIds == null) ? 0 : activityIds.hashCode());
        result = prime * result + ((activityOccurredDate == null) ? 0 : activityOccurredDate.hashCode());
        result = prime * result + ((activityOutcome == null) ? 0 : activityOutcome.hashCode());
        result = prime * result + ((activityStatus == null) ? 0 : activityStatus.hashCode());
        result = prime * result + ((activityType == null) ? 0 : activityType.hashCode());
        result = prime * result + ((caseActivityIdentification == null) ? 0 : caseActivityIdentification.hashCode());
        result = prime * result + ((caseAffiliationIds == null) ? 0 : caseAffiliationIds.hashCode());
        result = prime * result + ((caseIds == null) ? 0 : caseIds.hashCode());
        result = prime * result + ((chargeIds == null) ? 0 : chargeIds.hashCode());
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (obj == null) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        CaseActivityType other = (CaseActivityType) obj;
        if (activityCategory == null) {
            if (other.activityCategory != null) {
				return false;
			}
        } else if (!activityCategory.equals(other.activityCategory)) {
			return false;
		}
        if (activityComment == null) {
            if (other.activityComment != null) {
				return false;
			}
        } else if (!activityComment.equals(other.activityComment)) {
			return false;
		}
        if (activityIds == null) {
            if (other.activityIds != null) {
				return false;
			}
        } else if (!activityIds.equals(other.activityIds)) {
			return false;
		}
        if (activityOccurredDate == null) {
            if (other.activityOccurredDate != null) {
				return false;
			}
        } else if (!activityOccurredDate.equals(other.activityOccurredDate)) {
			return false;
		}
        if (activityOutcome == null) {
            if (other.activityOutcome != null) {
				return false;
			}
        } else if (!activityOutcome.equals(other.activityOutcome)) {
			return false;
		}
        if (activityStatus == null) {
            if (other.activityStatus != null) {
				return false;
			}
        } else if (!activityStatus.equals(other.activityStatus)) {
			return false;
		}
        if (activityType == null) {
            if (other.activityType != null) {
				return false;
			}
        } else if (!activityType.equals(other.activityType)) {
			return false;
		}
        if (caseActivityIdentification == null) {
            if (other.caseActivityIdentification != null) {
				return false;
			}
        } else if (!caseActivityIdentification.equals(other.caseActivityIdentification)) {
			return false;
		}
        if (caseAffiliationIds == null) {
            if (other.caseAffiliationIds != null) {
				return false;
			}
        } else if (!caseAffiliationIds.equals(other.caseAffiliationIds)) {
			return false;
		}
        if (caseIds == null) {
            if (other.caseIds != null) {
				return false;
			}
        } else if (!caseIds.equals(other.caseIds)) {
			return false;
		}
        if (chargeIds == null) {
            if (other.chargeIds != null) {
				return false;
			}
        } else if (!chargeIds.equals(other.chargeIds)) {
			return false;
		}
        return true;
    }

    @Override
    public String toString() {
        return "CaseActivityType [getCaseActivityIdentification()=" + getCaseActivityIdentification() + ", getActivityOccurredDate()=" + getActivityOccurredDate()
                + ", getActivityCategory()=" + getActivityCategory() + ", getActivityType()=" + getActivityType() + ", getActivityComment()=" + getActivityComment()
                + ", getActivityOutcome()=" + getActivityOutcome() + ", getOutcomeDate()=" + getOutcomeDate() + ", getActivityStatus()=" + getActivityStatus()
                + ", getChargeIds()=" + getChargeIds() + ", getCaseIds()=" + getCaseIds() + ", getActivityIds()=" + getActivityIds() + ", getCaseAffiliationIds()="
                + getCaseAffiliationIds() + ", getStamp()=" + getStamp() + "]";
    }

}
